#!/usr/bin/bash

# Source code data_race.c++

# Set up compiler environment
#
# e.g.:
# module add compiler/gnu
:

# Compile
#
# e.g.:
# c++ -fsanitize=thread -fopenmp -ggdb data_race.c++ -o data_race
make data_race

# Execute
exec ./data_race

"
==================
WARNING: ThreadSanitizer: data race (pid=9531)
  Read of size 4 at 0x7fff932716d0 by thread T6:
    #0 main._omp_fn.0 /.../data_race.c++:6 (data_race+0x12d1) (BuildId: cd933b5c0f71356a9b91dfd77e22a9deb01d915c)
    #1 gomp_thread_start /usr/src/debug/gcc/gcc/libgomp/team.c:129 (libgomp.so.1+0x20c95) (BuildId: fc33555746a3cc8252ac35fe69dd6367cdf255f3)

  Previous write of size 4 at 0x7fff932716d0 by main thread:
    #0 main._omp_fn.0 /.../data_race.c++:6 (data_race+0x12e6) (BuildId: cd933b5c0f71356a9b91dfd77e22a9deb01d915c)
    #1 GOMP_parallel /usr/src/debug/gcc/gcc/libgomp/parallel.c:178 (libgomp.so.1+0x16e25) (BuildId: fc33555746a3cc8252ac35fe69dd6367cdf255f3)
    #2 <null> <null> (libc.so.6+0x2384f) (BuildId: 2f005a79cd1a8e385972f5a102f16adba414d75e)

  Location is stack of main thread.

  Location is global '<null>' at 0x000000000000 ([stack]+0x1e6d0)

  Thread T6 (tid=9544, running) created by main thread at:
    #0 pthread_create /usr/src/debug/gcc/gcc/libsanitizer/tsan/tsan_interceptors_posix.cpp:1036 (libtsan.so.2+0x44229) (BuildId: 9d065bd30b0fe24a00130cc697ddbef1e5a9addf)
    #1 gomp_team_start /usr/src/debug/gcc/gcc/libgomp/team.c:858 (libgomp.so.1+0x212df) (BuildId: fc33555746a3cc8252ac35fe69dd6367cdf255f3)
    #2 <null> <null> (libc.so.6+0x2384f) (BuildId: 2f005a79cd1a8e385972f5a102f16adba414d75e)

SUMMARY: ThreadSanitizer: data race /.../data_race.c++:6 in main._omp_fn.0
==================
==================
WARNING: ThreadSanitizer: data race (pid=9531)
  Write of size 4 at 0x7fff932716d0 by thread T6:
    #0 main._omp_fn.0 /.../data_race.c++:6 (data_race+0x12e6) (BuildId: cd933b5c0f71356a9b91dfd77e22a9deb01d915c)
    #1 gomp_thread_start /usr/src/debug/gcc/gcc/libgomp/team.c:129 (libgomp.so.1+0x20c95) (BuildId: fc33555746a3cc8252ac35fe69dd6367cdf255f3)

  Previous write of size 4 at 0x7fff932716d0 by thread T1:
    #0 main._omp_fn.0 /.../data_race.c++:6 (data_race+0x12e6) (BuildId: cd933b5c0f71356a9b91dfd77e22a9deb01d915c)
    #1 gomp_thread_start /usr/src/debug/gcc/gcc/libgomp/team.c:129 (libgomp.so.1+0x20c95) (BuildId: fc33555746a3cc8252ac35fe69dd6367cdf255f3)

  Location is stack of main thread.

  Location is global '<null>' at 0x000000000000 ([stack]+0x1e6d0)

  Thread T6 (tid=9544, running) created by main thread at:
    #0 pthread_create /usr/src/debug/gcc/gcc/libsanitizer/tsan/tsan_interceptors_posix.cpp:1036 (libtsan.so.2+0x44229) (BuildId: 9d065bd30b0fe24a00130cc697ddbef1e5a9addf)
    #1 gomp_team_start /usr/src/debug/gcc/gcc/libgomp/team.c:858 (libgomp.so.1+0x212df) (BuildId: fc33555746a3cc8252ac35fe69dd6367cdf255f3)
    #2 <null> <null> (libc.so.6+0x2384f) (BuildId: 2f005a79cd1a8e385972f5a102f16adba414d75e)

  Thread T1 (tid=9539, running) created by main thread at:
    #0 pthread_create /usr/src/debug/gcc/gcc/libsanitizer/tsan/tsan_interceptors_posix.cpp:1036 (libtsan.so.2+0x44229) (BuildId: 9d065bd30b0fe24a00130cc697ddbef1e5a9addf)
    #1 gomp_team_start /usr/src/debug/gcc/gcc/libgomp/team.c:858 (libgomp.so.1+0x212df) (BuildId: fc33555746a3cc8252ac35fe69dd6367cdf255f3)
    #2 <null> <null> (libc.so.6+0x2384f) (BuildId: 2f005a79cd1a8e385972f5a102f16adba414d75e)

SUMMARY: ThreadSanitizer: data race /.../data_race.c++:6 in main._omp_fn.0
==================
==================
WARNING: ThreadSanitizer: data race (pid=9531)
  Write of size 4 at 0x7fff932716d0 by thread T4:
    #0 main._omp_fn.0 /.../data_race.c++:6 (data_race+0x12e6) (BuildId: cd933b5c0f71356a9b91dfd77e22a9deb01d915c)
    #1 gomp_thread_start /usr/src/debug/gcc/gcc/libgomp/team.c:129 (libgomp.so.1+0x20c95) (BuildId: fc33555746a3cc8252ac35fe69dd6367cdf255f3)

  Previous read of size 4 at 0x7fff932716d0 by thread T7:
    #0 main._omp_fn.0 /.../data_race.c++:6 (data_race+0x12d1) (BuildId: cd933b5c0f71356a9b91dfd77e22a9deb01d915c)
    #1 gomp_thread_start /usr/src/debug/gcc/gcc/libgomp/team.c:129 (libgomp.so.1+0x20c95) (BuildId: fc33555746a3cc8252ac35fe69dd6367cdf255f3)

  Location is stack of main thread.

  Location is global '<null>' at 0x000000000000 ([stack]+0x1e6d0)

  Thread T4 (tid=9542, running) created by main thread at:
    #0 pthread_create /usr/src/debug/gcc/gcc/libsanitizer/tsan/tsan_interceptors_posix.cpp:1036 (libtsan.so.2+0x44229) (BuildId: 9d065bd30b0fe24a00130cc697ddbef1e5a9addf)
    #1 gomp_team_start /usr/src/debug/gcc/gcc/libgomp/team.c:858 (libgomp.so.1+0x212df) (BuildId: fc33555746a3cc8252ac35fe69dd6367cdf255f3)
    #2 <null> <null> (libc.so.6+0x2384f) (BuildId: 2f005a79cd1a8e385972f5a102f16adba414d75e)

  Thread T7 (tid=9545, running) created by main thread at:
    #0 pthread_create /usr/src/debug/gcc/gcc/libsanitizer/tsan/tsan_interceptors_posix.cpp:1036 (libtsan.so.2+0x44229) (BuildId: 9d065bd30b0fe24a00130cc697ddbef1e5a9addf)
    #1 gomp_team_start /usr/src/debug/gcc/gcc/libgomp/team.c:858 (libgomp.so.1+0x212df) (BuildId: fc33555746a3cc8252ac35fe69dd6367cdf255f3)
    #2 <null> <null> (libc.so.6+0x2384f) (BuildId: 2f005a79cd1a8e385972f5a102f16adba414d75e)

SUMMARY: ThreadSanitizer: data race /.../data_race.c++:6 in main._omp_fn.0
==================
2
ThreadSanitizer: reported 3 warnings
"
