#!/usr/bin/bash

# Source code use_after_free.c++

# Set up compiler environment
#
# e.g.:
# module add compiler/gnu

# Compile
#
# e.g.:
# g++ -fanalyzer use_after_free.c++ -o use_after_free
exec make use_after_free

"
use_after_free.c++: In function 'int main(int, char**)':
use_after_free.c++:6:29: warning: dereference of NULL 'charArray' [CWE-476] [-Wanalyzer-null-dereference]
    6 |     std::cout << charArray[0] << std::endl;
      |                  ~~~~~~~~~~~^
  'int main(int, char**)': events 1-5
    |
    |    4 |     char *charArray = new char[10];
    |      |                                  ^
    |      |                                  |
    |      |                                  (1) allocated here
    |    5 |     delete[] charArray;
    |      |     ~~~~~~~~~~~~~~~~~~
    |      |     |
    |      |     (2) assuming 'charArray' is NULL
    |      |     (3) following 'false' branch (when 'charArray' is NULL)...
    |    6 |     std::cout << charArray[0] << std::endl;
    |      |                  ~~~~~~~~~~~~
    |      |                             |
    |      |                             (4) ...to here
    |      |                             (5) dereference of NULL 'charArray'
    |
use_after_free.c++:6:29: warning: use after 'delete[]' of 'charArray' [CWE-416] [-Wanalyzer-use-after-free]
    6 |     std::cout << charArray[0] << std::endl;
      |                  ~~~~~~~~~~~^
  'int main(int, char**)': events 1-6
    |
    |    4 |     char *charArray = new char[10];
    |      |                                  ^
    |      |                                  |
    |      |                                  (1) allocated here
    |    5 |     delete[] charArray;
    |      |     ~~~~~~~~~~~~~~~~~~
    |      |     |        |
    |      |     |        (4) ...to here
    |      |     |        (5) deleted here
    |      |     (2) assuming 'charArray' is non-NULL
    |      |     (3) following 'true' branch (when 'charArray' is non-NULL)...
    |    6 |     std::cout << charArray[0] << std::endl;
    |      |                  ~~~~~~~~~~~~
    |      |                             |
    |      |                             (6) use after 'delete[]' of 'charArray'; deleted at (5)
    |
"
