#!/usr/bin/bash

# Source code deadlock.c

# Set up compiler environment
#
# e.g.:
# module purge
# module add \
#     compiler/gnu \
#     mpi/openmpi
:

# Compile
#
# e.g.:
# mpicc -ggdb deadlock.c -o deadlock
make deadlock

# Execute with GDB server (e.g. in batch job)
# * Only on first MPI rank
exec mpirun -np 4 --bind-to core --map-by core bash -c \
    'COMMAND=( ./deadlock )
     if [[ ${OMPI_COMM_WORLD_RANK} -eq 0 ]]; then
         exec gdbserver *:8080 \
            "${COMMAND[@]}"
     else
         exec "${COMMAND[@]}"
     fi'

"
Process ./deadlock created; pid = 29708
Listening on port 8080
Remote debugging from host ::1, port 41498
"
