#!/usr/bin/bash

# Set up build environment
#
# e.g.:
# module purge
# module add compiler/gnu
:

# Build stream benchmark
make stream

# Set up OpenMP environment
export OMP_NUM_THREADS=1
export OMP_PROC_BIND=TRUE
export OMP_PLACES=cores

# Ltrace
#  * Filter for `alloc` and `free` functions calls within the stream binary
#    (ignoring these calls within libraries).
#  * Discard standard output

exec \
  ltrace \
    --demangle \
    -e *alloc*@stream+free@stream \
    ./stream \
    >/dev/null

"
stream->aligned_alloc(64, 0x4c4b400, 0x562b2ab296c0, 1)                                                          = 0x7f6e98209040
stream->aligned_alloc(64, 0x4c4b400, 0x4c4bfd2, 0x7f6e98209010)                                                  = 0x7f6e935bd040
stream->aligned_alloc(64, 0x4c4b400, 0x4c4bfd2, 0x7f6e935bd010)                                                  = 0x7f6e8e971040
stream->free(0x7f6e98209040)                                                                                     = <void>
stream->free(0x7f6e935bd040)                                                                                     = <void>
stream->free(0x7f6e8e971040)                                                                                     = <void>

-> memory allocation and free for vectors a, b and c
"
