#!/usr/bin/bash

# Set up build environment
#
# e.g.:
# module purge
# module add \
#     compiler/gnu \
#     mpi/openmpi
# module add devel/strace
:

# Build rank_league benchmark
make rank_league

# Ltrace all MPI ranks to individual files (e.g. for comparison)

exec mpirun -np 4 --bind-to core --map-by core bash -c \
      'ltrace -o ltrace.out.${OMPI_COMM_WORLD_RANK} \
           ./rank_league'

"
ll -h ltrace.out.*

-rw-r--r-- 1 holgerob users 191K 11. Mai 16:27 ltrace.out.0
-rw-r--r-- 1 holgerob users 188K 11. Mai 16:27 ltrace.out.1
-rw-r--r-- 1 holgerob users 188K 11. Mai 16:27 ltrace.out.2
-rw-r--r-- 1 holgerob users 188K 11. Mai 16:27 ltrace.out.3
"
