#!/usr/bin/bash

# Set up build environment
#
# e.g.:
# module purge
# module add \
#     compiler/gnu \
#     mpi/openmpi
# module add devel/strace
:

# Build rank_league benchmark
make rank_league

# Ltrace
#  * Only on first MPI rank (e.g. for data reduction)
#  * Redirect trace to file

exec mpirun -np 4 --bind-to core --map-by core bash -c \
      'if [[ ${OMPI_COMM_WORLD_RANK} -eq 0 ]]; then
           exec ltrace -o ltrace.out \
                ./rank_league
       else
           exec ./rank_league
       fi'

"
****** Running bandwidth test ********
Total number of rounds:          3
Total number of loops per round: 200
Message size:                    100000
**************************************
Round number     3
**************************************
RANKS    RESULTS
________________
0 -- 1    509.30
0 -- 2    500.31
0 -- 3    505.73
1 -- 0    486.98
1 -- 2   3490.26
1 -- 3   3714.29
2 -- 0    427.70
2 -- 1   2700.22
2 -- 3   2818.25
3 -- 0    350.73
3 -- 1   2637.45
3 -- 2   3375.04
___________________________________________________________
Global statistics:
 MIN      350.73 between 3 and 0
 MAX     3714.29 between 1 and 3
 AVERAGE 1793.02

-> All communication with MPI rank 0 is much slower
-> Overhead of ltrace

ll -h ltrace.out

-rw-r--r-- 1 holgerob users 191K 11. Mai 16:31 ltrace.out
"
