#!/usr/bin/bash

# Set up strace and build environment
#
# e.g.:
# module purge
# module add compiler/gnu
# module add devel/strace
:

# Build stream benchmark
make stream

# Set up OpenMP environment
export OMP_NUM_THREADS=4
export OMP_PROC_BIND=TRUE
export OMP_PLACES=cores

# Filter for syscalls containing "open"
# * Discard standard output
# * Show only successfull syscalls
exec strace --trace='/.*open.*' --status=successful ./stream 1>/dev/null

'
openat(AT_FDCWD, "/etc/ld.so.cache", O_RDONLY|O_CLOEXEC) = 3
openat(AT_FDCWD, "/usr/lib/libm.so.6", O_RDONLY|O_CLOEXEC) = 3
openat(AT_FDCWD, "/usr/lib/libgomp.so.1", O_RDONLY|O_CLOEXEC) = 3
openat(AT_FDCWD, "/usr/lib/libc.so.6", O_RDONLY|O_CLOEXEC) = 3
openat(AT_FDCWD, "/sys/devices/system/cpu/possible", O_RDONLY|O_CLOEXEC) = 3
openat(AT_FDCWD, "/sys/devices/system/cpu/cpu0/topology/core_siblings_list", O_RDONLY) = 3
openat(AT_FDCWD, "/sys/devices/system/cpu/cpu0/topology/thread_siblings_list", O_RDONLY) = 4
openat(AT_FDCWD, "/sys/devices/system/cpu/cpu1/topology/thread_siblings_list", O_RDONLY) = 4
openat(AT_FDCWD, "/sys/devices/system/cpu/cpu2/topology/thread_siblings_list", O_RDONLY) = 4
openat(AT_FDCWD, "/sys/devices/system/cpu/cpu3/topology/thread_siblings_list", O_RDONLY) = 4
+++ exited with 0 +++
'
