#!/usr/bin/bash

# Set up strace and build environment
#
# e.g.:
# module purge
# module add \
#     compiler/gnu \
#     mpi/openmpi
# module add devel/strace
:

# Build rank_league benchmark
make rank_league

# Strace all MPI ranks to individual files (e.g. for comparison)
exec mpirun -np 4 --bind-to core --map-by core bash -c \
      'strace -o strace.out.${OMPI_COMM_WORLD_RANK} \
           ./rank_league'

"
ll -h strace.out.*

-rw-r--r-- 1 holgerob users 1,9M 11. Mai 17:10 strace.out.0
-rw-r--r-- 1 holgerob users 1,7M 11. Mai 17:10 strace.out.1
-rw-r--r-- 1 holgerob users 1,8M 11. Mai 17:10 strace.out.2
-rw-r--r-- 1 holgerob users 1,8M 11. Mai 17:10 strace.out.3
"
