#!/usr/bin/bash

# Set up strace and build environment
#
# e.g.:
# module purge
# module add \
#     compiler/gnu \
#     mpi/openmpi
# module add devel/strace
:

# Build rank_league benchmark
make rank_league

# Strace
#  * Only on first MPI rank (e.g. for strace data reduction)
#  * Redirect trace to file

exec mpirun -np 4 --bind-to core --map-by core bash -c \
      'if [[ ${OMPI_COMM_WORLD_RANK} -eq 0 ]]; then
           exec strace -o strace.out \
                ./rank_league
       else
           exec ./rank_league
       fi'

"
****** Running bandwidth test ********
Total number of rounds:          3
Total number of loops per round: 200
Message size:                    100000
**************************************
Round number     3
**************************************
RANKS    RESULTS
________________
0 -- 1    770.32
0 -- 2    777.73
0 -- 3    699.34
1 -- 0    717.93
1 -- 2   3935.31
1 -- 3   2933.62
2 -- 0    709.36
2 -- 1   3074.05
2 -- 3   2672.57
3 -- 0    675.65
3 -- 1   3956.30
3 -- 2   3915.77
___________________________________________________________
Global statistics:
 MIN      675.65 between 3 and 0
 MAX     3956.30 between 3 and 1
 AVERAGE 2069.83

-> All communication with MPI rank 0 is slower
-> Overhead of strace

ll -h strace.out

-rw-r--r-- 1 holgerob users 1,7M 11. Mai 17:13 strace.out
"
