#!/usr/bin/bash

# Source code deadlock.c

# Set up compiler environment
#
# e.g.:
# module purge
# module add \
#     compiler/gnu \
#     mpi/openmpi
:

# Compile
#
# e.g.:
# mpicc -ggdb deadlock.c -o deadlock
make deadlock

# Open workspace folder, launch config and source code in visual studio code
code . .vscode/launch.json deadlock.c

# Execute with GDB server (e.g. in batch job)
#  * Only on first and second MPI rank
exec mpirun -np 4 --bind-to core --map-by core bash -c \
    'COMMAND=( ./deadlock )
     if [[ ${OMPI_COMM_WORLD_RANK} -eq 0 ]]; then
         exec gdbserver *:8080 \
            "${COMMAND[@]}"
     elif [[ ${OMPI_COMM_WORLD_RANK} -eq 1 ]]; then
         exec gdbserver *:8081 \
            "${COMMAND[@]}"
      else
         exec "${COMMAND[@]}"
     fi'

"
Process ./deadlock created; pid = 25656
Listening on port 8081
Process ./deadlock created; pid = 25655
Listening on port 8080
Remote debugging from host ::1, port 35992
Remote debugging from host ::1, port 50904
"
