#!/usr/bin/bash

# Source code rank_league.c

# Set up compiler environment
#
# e.g.:
# module purge
# module add \
#     compiler/gnu \
#     mpi/openmpi
:

# Compile
#
# e.g.:
# mpicc -ggdb rank_league.c -o rank_league
make rank_league

# Open workspace folder, launch config and source code in visual studio code
code . .vscode/launch.json rank_league.c

# Execute with GDB server (e.g. in batch job)
# * Only on first MPI rank
exec mpirun -np 4 --bind-to core --map-by core bash -c \
    'COMMAND=( ./rank_league )
     if [[ ${OMPI_COMM_WORLD_RANK} -eq 0 ]]; then
         exec gdbserver *:8080 \
            "${COMMAND[@]}"
     else
         exec "${COMMAND[@]}"
     fi'

"
Process ./rank_league created; pid = 26431
Listening on port 8080
Remote debugging from host ::1, port 55962
"
