#!/usr/bin/bash

# Source code use_after_free.c++

# Set up valgrind and build environment
#
# e.g.:
# module add \
#     compiler/gnu \
#     devel/valgrind
:

# Build application
#
# e.g.:
# g++ -ggdb use_after_free.c++ -o use_after_free
make use_after_free

# Examine use_after_free program with valgrind memchecker
exec valgrind ./use_after_free

"
==17690== Memcheck, a memory error detector
==17690== Copyright (C) 2002-2022, and GNU GPL'd, by Julian Seward et al.
==17690== Using Valgrind-3.20.0 and LibVEX; rerun with -h for copyright info
==17690== Command: ./use_after_free
==17690==
==17690== Invalid read of size 1
==17690==    at 0x10919D: main (use_after_free.c++:6)
==17690==  Address 0x4e22080 is 0 bytes inside a block of size 10 free'd
==17690==    at 0x4845A7F: operator delete[](void*) (vg_replace_malloc.c:1115)
==17690==    by 0x109198: main (use_after_free.c++:5)
==17690==  Block was alloc'd at
==17690==    at 0x48432E3: operator new[](unsigned long) (vg_replace_malloc.c:652)
==17690==    by 0x109181: main (use_after_free.c++:4)
==17690==

==17690==
==17690== HEAP SUMMARY:
==17690==     in use at exit: 0 bytes in 0 blocks
==17690==   total heap usage: 3 allocs, 3 frees, 74,762 bytes allocated
==17690==
==17690== All heap blocks were freed -- no leaks are possible
==17690==
==17690== For lists of detected and suppressed errors, rerun with: -s
==17690== ERROR SUMMARY: 1 errors from 1 contexts (suppressed: 0 from 0)
"
